Index: res/res_agi.c
===================================================================
--- res/res_agi.c	(revision 10446)
+++ res/res_agi.c	(working copy)
@@ -36,6 +36,7 @@
 #include <stdlib.h>
 #include <signal.h>
 #include <sys/time.h>
+#include <sys/stat.h>
 #include <stdio.h>
 #include <fcntl.h>
 #include <errno.h>
@@ -228,6 +229,7 @@
 	int x;
 	int res;
 	sigset_t signal_set;
+	struct stat sb;
 	
 	if (!strncasecmp(script, "agi://", 6))
 		return launch_netscript(script, argv, fds, efd, opid);
@@ -236,6 +238,14 @@
 		snprintf(tmp, sizeof(tmp), "%s/%s", (char *)ast_config_AST_AGI_DIR, script);
 		script = tmp;
 	}
+	if (stat(script, &sb) !=0 ) {
+		ast_log(LOG_WARNING, "Script %s not found: %s\n", script, strerror(errno));
+		return -1;
+	}
+	if (access(script, X_OK) !=0 ) {
+		ast_log(LOG_WARNING, "Script %s is not executable: %s\n", script, strerror(errno));
+		return -1;
+	}
 	if (pipe(toast)) {
 		ast_log(LOG_WARNING, "Unable to create toast pipe: %s\n",strerror(errno));
 		return -1;
